diff --git a/src/decode_r11.c b/src/decode_r11.c
index 2f7e49681c..cbcf3ead89 100644
--- a/src/decode_r11.c
+++ b/src/decode_r11.c
@@ -703,6 +703,7 @@ decode_preR13 (Bit_Chain *restrict dat, Dwg_Data *restrict dwg)
   error |= dwg_add_Document (dwg, 0);
   if (error >= DWG_ERR_CRITICAL)
     return error;
+  dwg->opts &= ~DWG_OPTS_IN;
 
   PRE (R_2_0b)
   {
diff --git a/src/dwg.spec b/src/dwg.spec
index 66cb53e119..31fdf6af37 100644
--- a/src/dwg.spec
+++ b/src/dwg.spec
@@ -1238,13 +1238,38 @@ DWG_ENTITY (POLYLINE_2D)
       FIELD_RD (end_width, 41);
     if (R11OPTS (8))
       FIELD_3RD (extrusion, 210);
-    //if (R11OPTS (256)) // 16? but this is already in flags_r11 70
-    //  FIELD_RS (curve_type, 75);
+    if (R11OPTS (0x8000)) {
+      DECODER {
+        // GH #5480> curve_fit vertex
+        if (_ent->flag_r11 == 0 && obj->size > 20)
+          {
+            BITCODE_2RD pt;
+            BITCODE_RC flag = FIELD_VALUE (flag);
+            Dwg_Entity_VERTEX_2D *v;
+            pt.x = bit_read_RD (dat);
+            pt.y = bit_read_RD (dat);
+            LOG_TRACE ("=> VERTEX_2D: (%f, %f) [2RD 10]\n", pt.x, pt.y);
+            ((Dwg_Object*)obj)->fixedtype = DWG_TYPE_VERTEX_2D;
+            ((Dwg_Object*)obj)->type = DWG_TYPE_VERTEX_R11;
+            ((Dwg_Object*)obj)->dxfname = (char *)"VERTEX";
+            ((Dwg_Object*)obj)->name = (char *)"VERTEX_2D";
+            v = obj->tio.entity->tio.VERTEX_2D;
+            v->flag = flag | FLAG_VERTEX_EXTRA_VERTEX;
+            v->point.x = pt.x;
+            v->point.y = pt.y;
+            _obj = (Dwg_Entity_POLYLINE_2D *)v;
+          }
+        else if (_ent->flag_r11 == 0)
+          {
+            FIELD_VALUE (flag) |= FLAG_POLYLINE_CURVE_FIT;
+            FIELD_VALUE (curve_type) = 5;
+            LOG_TRACE ("=> FLAG_POLYLINE_CURVE_FIT\n");
+          }
+      }
+    }
     //  LOG_POLYLINE_CURVETYPE
     DECODER {
-      //TODO FIELD_VALUE (curve_type) = 0-8;
       FIELD_VALUE (has_vertex) = R11FLAG (FLAG_R11_HAS_ATTRIBS) ? 1 : 0;
-      //LOG_TRACE ("=> has_vertex: %d\n", FIELD_VALUE (has_vertex))
     }
     DXF {
       FIELD_RS0 (curve_type, 75);
